## org.eclipse.xsd.impl
Class XSDSchemaImpl

    java.lang.Object
      org.eclipse.emf.common.notify.impl.BasicNotifierImpl
          org.eclipse.emf.ecore.impl.BasicEObjectImpl
              org.eclipse.emf.ecore.impl.EObjectImpl
                  org.eclipse.xsd.impl.XSDConcreteComponentImpl
                      org.eclipse.xsd.impl.XSDComponentImpl
                          org.eclipse.xsd.impl.XSDScopeImpl
                              org.eclipse.xsd.impl.XSDSchemaImpl

All Implemented Interfaces:
  Notifier, EObject, InternalEObject, XSDComponent, XSDConcreteComponent, XSDSchema, XSDScope

    public class XSDSchemaImpl

extends XSDScopeImpl
implements XSDSchema

An implementation of the model object 'Schema'.

The following features are implemented:

- `Document`
- `Schema Location`
- `Target Namespace`
- `Attribute Form Default`
- `Element Form Default`
- `Final Default`
- `Block Default`
- `Version`
- `Contents`
- `Element Declarations`
- `Attribute Declarations`
- `Attribute Group Definitions`
- `Type Definitions`
- `Model Group Definitions`
- `Identity Constraint Definitions`
- `Notation Declarations`
- `Annotations`
- `All Diagnostics`
- `Referencing Directives`
- `Root Version`
- `Original Version`
- `Incorporated Versions`
- `Schema For Schema`

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl
`XSDConcreteComponentImpl.XSDContentsEList`

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`BasicEObjectImpl.EPropertiesHolder, BasicEObjectImpl.EPropertiesHolderBaseImpl, BasicEObjectImpl.EPropertiesHolderImpl`

Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`BasicNotifierImpl.EAdapterList<E extends java.lang.Object & Adapter>`

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject
`InternalEObject.EStore`

Field Summary
`protected EList<XSDDiagnostic>` `allDiagnostics` The cached value of the '`All Diagnostics`' reference list
`protected EList<XSDAnnotation>` `annotations` The cached value of the '`Annotations`' reference list
`protected static XSDForm` `ATTRIBUTE_FORM_DEFAULT_EDEFAULT` The default value of the '`Attribute Form Default`' attribute
`protected static int` `ATTRIBUTE_FORM_DEFAULT_ESETFLAG` The flag representing whether the Attribute Form Default attribute has been set
`protected EList<XSDAttributeDeclaration>` `attributeDeclarations` The cached value of the '`Attribute Declarations`' reference list
`protected XSDForm` `attributeFormDefault` The cached value of the '`Attribute Form Default`' attribute
`protected EList<XSDAttributeGroupDefinition>` `attributeGroupDefinitions` The cached value of the '`Attribute Group Definitions`' reference list
`protected EList<XSDDisallowedSubstitutions>` `blockDefault` The cached value of the '`Block Default`' attribute list
`protected java.util.Collection<XSDSchemaImpl>` `circularResolveDependencies`
`protected EList<XSDSchemaContent>` `contents` The cached value of the '`Contents`' containment reference list
`protected org.w3c.dom.Node` `deletionNode`
`protected org.w3c.dom.Document` `document` The cached value of the '`Document`' attribute
`protected static org.w3c.dom.Document` `DOCUMENT_EDEFAULT` The default value of the '`Document`' attribute
`protected static XSDForm` `ELEMENT_FORM_DEFAULT_EDEFAULT` The default value of the '`Element Form Default`' attribute
`protected static int` `ELEMENT_FORM_DEFAULT_ESETFLAG` The flag representing whether the Element Form Default attribute has been set
`protected EList<XSDElementDeclaration>` `elementDeclarations` The cached value of the '`Element Declarations`' reference list
`protected XSDForm` `elementFormDefault` The cached value of the '`Element Form Default`' attribute
`protected org.w3c.dom.events.EventListener` `eventListener`
`protected EList<XSDProhibitedSubstitutions>` `finalDefault` The cached value of the '`Final Default`' attribute list
`protected static ResourceSet` `globalResourceSet`
`protected boolean` `hasRetargetedNamespace`
`protected EList<XSDIdentityConstraintDefinition>` `identityConstraintDefinitions` The cached value of the '`Identity Constraint Definitions`' reference list
`protected EList<XSDSchema>` `incorporatedVersions` The cached value of the '`Incorporated Versions`' containment reference list
`protected java.util.List<XSDSchema>` `incorporatingSchemas`
`protected boolean` `isIncrementalUpdate`
`protected EList<XSDModelGroupDefinition>` `modelGroupDefinitions` The cached value of the '`Model Group Definitions`' reference list
`protected EList<XSDNotationDeclaration>` `notationDeclarations` The cached value of the '`Notation Declarations`' reference list
`protected java.lang.String` `pendingSchemaLocation`
`protected java.util.Map<java.lang.String,java.lang.String>` `qNamePrefixToNamespaceMap`
`protected java.util.Map<XSDComponent,XSDComponent>` `redefinitionMap`
`protected EList<XSDSchemaDirective>` `referencingDirectives` The cached value of the '`Referencing Directives`' reference list
`protected static java.lang.String` `SCHEMA_LOCATION_EDEFAULT` The default value of the '`Schema Location`' attribute
`protected java.lang.String` `schemaForSchemaQNamePrefix`
`protected java.lang.String` `schemaLocation` The cached value of the '`Schema Location`' attribute
`protected java.util.List<XSDSchemaImpl>` `schemasToRedefine`
`protected java.util.Map<java.lang.String,XSDSimpleTypeDefinition>` `simpleTypeIdMap`
`protected static java.lang.String` `TARGET_NAMESPACE_EDEFAULT` The default value of the '`Target Namespace`' attribute
`protected java.lang.String` `targetNamespace` The cached value of the '`Target Namespace`' attribute
`protected EList<XSDTypeDefinition>` `typeDefinitions` The cached value of the '`Type Definitions`' reference list
`protected java.lang.String` `version` The cached value of the '`Version`' attribute
`protected static java.lang.String` `VERSION_EDEFAULT` The default value of the '`Version`' attribute
`protected static XSDSchema` `xsdMagicSchemaForSchema1999`
`protected static XSDSchema` `xsdMagicSchemaForSchema2000_10`
`protected static XSDSchema` `xsdMagicSchemaForSchema2001`
`protected static XSDSchema` `xsdSchemaForSchema1999`
`protected static XSDSchema` `xsdSchemaForSchema2000_10`
`protected static XSDSchema` `xsdSchemaForSchema2001`
`protected static XSDSchema` `xsdSchemaInstance2001`

Fields inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl
`ANALYZED, ANALYZING, CIRCULAR, diagnostics, element, ELEMENT_EDEFAULT, ERROR, FATAL, forceResolve, INFORMATION, isReconciling, UNANALYZED, updatingDOM, WARNING, xsdContents`

Fields inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eContainer, eContainerFeatureID, EDELIVER, EDYNAMIC_CLASS, eFlags, ELAST_EOBJECT_FLAG, ELAST_NOTIFIER_FLAG, eProperties, EPROXY`

Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

Fields inherited from interface org.eclipse.emf.ecore.InternalEObject
`EOPPOSITE_FEATURE_BASE`

Constructor Summary
`protected` `XSDSchemaImpl()`

Method Summary
`protected void` `adoptContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected boolean` `analyze()`
`protected void` `changeAttribute(EAttribute eAttribute)`
`protected void` `changeReference(EReference eReference)`
`XSDConcreteComponent` `cloneConcreteComponent(boolean deep, boolean shareDOM)` Creates a clone of the component.
`protected void` `computeSchemasToPatch(XSDSchema root, java.util.List<XSDSchema> schemasToPatch)`
`org.w3c.dom.Element` `createElement()`
`static XSDSchema` `createMetaSchema(org.w3c.dom.Node node)`
`static ResourceSet` `createResourceSet()`
`static XSDSchema` `createSchema(org.w3c.dom.Node node)`
`java.lang.Object` `eGet(int featureID, boolean resolve, boolean coreType)`
`NotificationChain` `eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)`
`boolean` `eIsSet(int featureID)`
`void` `eSet(int featureID, java.lang.Object newValue)`
`protected EClass` `eStaticClass()`
`void` `eUnset(int featureID)`
`EList<XSDDiagnostic>` `getAllDiagnostics()`
`EList<XSDAnnotation>` `getAnnotations()`
`EList<XSDAttributeDeclaration>` `getAttributeDeclarations()`
`XSDForm` `getAttributeFormDefault()`
`EList<XSDAttributeGroupDefinition>` `getAttributeGroupDefinitions()`
`EList<XSDDisallowedSubstitutions>` `getBlockDefault()`
`EList<XSDSchemaContent>` `getContents()`
`XSDConcreteComponent` `getCorrespondingComponent(org.w3c.dom.Node node)` Returns the best concrete component that corresponds to the given node.
`org.w3c.dom.Node` `getDeletionNode()`
`org.w3c.dom.Document` `getDocument()`
`EList<XSDElementDeclaration>` `getElementDeclarations()`
`XSDForm` `getElementFormDefault()`
`protected org.w3c.dom.events.EventListener` `getEventListener()`
`EList<XSDProhibitedSubstitutions>` `getFinalDefault()`
`static ResourceSet` `getGlobalResourceSet()`
`EList<XSDIdentityConstraintDefinition>` `getIdentityConstraintDefinitions()`
`EList<XSDSchema>` `getIncorporatedVersions()`
`protected java.util.List<XSDSchema>` `getIncorporatingSchemas()`
`XSDSchema` `getMagicSchemaForSchema()`
`static XSDSchema` `getMagicSchemaForSchema(java.lang.String namespace)`
`EList<XSDModelGroupDefinition>` `getModelGroupDefinitions()`
`EList<XSDNotationDeclaration>` `getNotationDeclarations()`
`XSDSchema` `getOriginalVersion()` Returns the value of the 'Original Version' reference
`java.lang.String` `getPendingSchemaLocation()`
`java.util.Map<java.lang.String,java.lang.String>` `getQNamePrefixToNamespaceMap()` This returns the map defined by the xmlns attributes of the underlying XML representation.
`java.util.Map<XSDComponent,XSDComponent>` `getRedefinitionMap()`
`EList<XSDSchemaDirective>` `getReferencingDirectives()`
`XSDSchema` `getRootVersion()` Returns the value of the 'Root Version' reference
`XSDSchema` `getSchemaForSchema()` Returns the value of the 'Schema For Schema' reference
`static XSDSchema` `getSchemaForSchema(java.lang.String namespace)`
`java.lang.String` `getSchemaForSchemaNamespace()` This returns (String)getQNamePrefixToNamespaceMap().get(getSchemaForSchemaQNamePrefix()); you can't set this directly.
`java.lang.String` `getSchemaForSchemaQNamePrefix()` This returns the QName prefix used to reference the schema for schema; it must be a key in `getQNamePrefixToNamespaceMap()`.
`static XSDSchema` `getSchemaInstance(java.lang.String namespace)`
`java.lang.String` `getSchemaLocation()`
`java.util.List<XSDSchemaImpl>` `getSchemasToRedefine()`
`java.util.Map<java.lang.String,XSDSimpleTypeDefinition>` `getSimpleTypeIdMap()` Returns a map from String ID to `XSDSimpleTypeDefinition` based on the IDs in the DOM representation.
`java.lang.String` `getStringBlockDefault()` Returns the String value of the '`Block Default`' attribute list
`java.lang.String` `getStringFinalDefault()` Returns the String value of the '`Final Default`' attribute list
`java.lang.String` `getTargetNamespace()`
`EList<XSDTypeDefinition>` `getTypeDefinitions()`
`java.lang.String` `getVersion()`
`protected void` `handleReconciliation(java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`protected void` `handleUnreconciledElement(org.w3c.dom.Element child, java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`boolean` `hasRetargetedNamespace()`
`XSDSchema` `imported(XSDImport xsdImport)`
`XSDSchema` `included(XSDInclude xsdInclude)`
`protected void` `incorporate(XSDSchemaCompositor xsdSchemaCompositor)`
`boolean` `isIncrementalUpdate()` Returns whether the schema will incrementally resolve QNames and perform analysis after each edit change.
`boolean` `isSetAttributeFormDefault()`
`boolean` `isSetBlockDefault()`
`boolean` `isSetElementFormDefault()`
`boolean` `isSetFinalDefault()`
`protected void` `orphanContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected void` `patch()`
`protected void` `patchContents()`
`void` `propogateComponents(XSDSchema otherXSDSchema)`
`protected void` `reconcileAttributes(org.w3c.dom.Element changedElement)`
`XSDSchema` `redefined(XSDRedefine xsdRedefine)`
`void` `reset()` Resets the effects of imports, includes, and redefines so that they will be reprocessed.
`protected void` `reset(java.util.List<? extends XSDConcreteComponent> components)`
`XSDAttributeDeclaration` `resolveAttributeDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute declaration of the given `namespace` and `name`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute group definition the given `namespace` and `name`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved complex type definition of the given `namespace` and `name`.
`XSDElementDeclaration` `resolveElementDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved element declaration of the given `namespace` and `name`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved identity constraint definition of the given `namespace` and `name`.
`XSDModelGroupDefinition` `resolveModelGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved model group definition of the given `namespace` and `name`.
`protected XSDNamedComponent` `resolveNamedComponent(EReference namedComponentsRefReference, java.lang.String namespace, java.lang.String localName)` This is a helper method for searching for a name in one of the schemas named component relations.
`XSDNotationDeclaration` `resolveNotationDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved notation declaration of the given `namespace` and `name`.
`java.util.Collection<XSDSchema>` `resolveSchema(java.lang.String namespace)` This returns set of schemas with the given namespace as it's target namespace.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved simple type definition of the given `namespace` and `name`.
`XSDTypeDefinition` `resolveTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved type definition of the given `namespace` and `name`.
`void` `setAttributeFormDefault(XSDForm newAttributeFormDefault)`
`void` `setDocument(org.w3c.dom.Document newDocument)`
`void` `setElement(org.w3c.dom.Element element)` Sets the value of the '`Element`' attribute
`void` `setElementFormDefault(XSDForm newElementFormDefault)`
`void` `setIncrementalUpdate(boolean isIncrementalUpdate)` Sets whether the schema will incrementally resolve QNames and perform analysis after each edit change.
`void` `setSchemaForSchemaQNamePrefix(java.lang.String qNamePrefix)` This sets the QName prefix used to reference the schema for schema; it must be a key in `getQNamePrefixToNamespaceMap()` that maps to a valid schema for schema namespace.
`void` `setSchemaLocation(java.lang.String newSchemaLocation)`
`void` `setStringBlockDefault(java.lang.String blockDefault)` Returns the String value of the '`Block Default`' attribute list
`void` `setStringFinalDefault(java.lang.String finalDefault)` Set the String value of the '`Final Default`' attribute list
`void` `setTargetNamespace(java.lang.String newTargetNamespace)`
`void` `setVersion(java.lang.String newVersion)`
`java.lang.String` `toString()`
`protected void` `traverseToRootForAnalysis()`
`protected void` `traverseToRootForPatching()`
`void` `unsetAttributeFormDefault()`
`void` `unsetBlockDefault()`
`void` `unsetElementFormDefault()`
`void` `unsetFinalDefault()`
`void` `update()` Resolves QNames and performs analysis.
`void` `update(boolean force)` Resolves QNames and performs analysis.
`org.w3c.dom.Document` `updateDocument()` Ensures that the `document` will be set to an instance that can be used to create a DOM serialization.
`protected void` `updateSortedList(XSDNamedComponent xsdNamedComponent)`
`void` `validate()` Validates whether this component conforms to the constraints defined in the XML Schema standard.
`void` `validateNoDuplicates(java.lang.String componentNoun, EList<? extends XSDNamedComponent> xsdNamedComponents)`

Methods inherited from class org.eclipse.xsd.impl.XSDConcreteComponentImpl

`adoptBy, adoptDiagnostic, checkAttributes, checkAttributeTypeConstraint, checkAttributeTypeConstraint, checkBuiltInTypeConstraint, checkComplexContent, checkComplexContent, checkElementComplexContent, checkSimpleTypeConstraint, clearDiagnostics, cloneConcreteComponents, considerAllContainsForBestConcreteComponent, contains, createDiagnostic, createDiagnostic, createDiagnostic, createDiagnostic, createElement, createRequiredAttributeDiagnostic, createUnresolvedAttributeDeclaration, createUnresolvedAttributeGroupDefinition, createUnresolvedComplexTypeDefinition, createUnresolvedElementDeclaration, createUnresolvedIdentityConstraintDefinition, createUnresolvedModelGroupDefinition, createUnresolvedNotationDeclaration, createUnresolvedSimpleTypeDefinition, createUnresolvedTypeDefinition, elementAttributesChanged, elementChanged, elementContentsChanged, eNotificationRequired, eNotify, eObjectForURIFragmentSegment, eURIFragmentSegment, forceEngulf, forceEngulf, forceNiceInsertBefore, forceNiceRemoveChild, forceReplace, getAdoptionParentNode, getBestConcreteComponent, getComponentsWithApplicationInformation, getComponentsWithInformation, getComponentsWithUserInformation, getContainer, getContentNodes, getDiagnostics, getDiagnosticTarget, getElement, getRootContainer, getSchema, getURIReferenceLabel, getXSDConcreteComponentImpls, getXSDContents, getXSDFactory, getXSDPackage, handleAnnotationReconciliation, handleElementForAdopt, isUpdatingDOM, moveContent, niceCreateNamespaceAttribute, niceInsertBefore, niceRemoveChild, niceSetAttribute, niceSetAttributeURIValue, orphanBy, orphanDiagnostic, populateDiagnostic, printDFA, reconcile, reconcileContents, reportConstraintViolation, resolveAttributeDeclaration, resolveAttributeDeclarationURI, resolveAttributeGroupDefinition, resolveAttributeGroupDefinitionURI, resolveComplexTypeDefinition, resolveComplexTypeDefinitionURI, resolveElementDeclaration, resolveElementDeclarationURI, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinitionURI, resolveModelGroupDefinition, resolveModelGroupDefinitionURI, resolveNotationDeclaration, resolveNotationDeclarationURI, resolveSimpleTypeDefinition, resolveSimpleTypeDefinitionURI, resolveTypeDefinition, resolveTypeDefinitionURI, setElementGen, setListContentAndOrder, updateElement, updateElement, updatePrefix`

Methods inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eBasicAdapters, eBasicProperties, eBasicSetContainer, eClass, eContainerFeatureID, eDeliver, eInternalContainer, eIsProxy, eProperties, eSetClass, eSetDeliver, eSetProxyURI`

Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicRemoveFromContainerFeature, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eContents, eCrossReferences, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDirectResource, eDynamicBasicRemoveFromContainer, eDynamicClass, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eHasSettings, eInternalResource, eInverseAdd, eInverseAdd, eInverseRemove, eIsSet, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eProxyURI, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetDirectResource, eSetResource, eSetStore, eSetting, eSettingDelegate, eSettings, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStore, eUnset, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.xsd.XSDConcreteComponent

`clearDiagnostics, contains, elementAttributesChanged, elementChanged, elementContentsChanged, getComponentsWithApplicationInformation, getComponentsWithUserInformation, getContainer, getDiagnostics, getElement, getRootContainer, getSchema, resolveAttributeDeclaration, resolveAttributeDeclarationURI, resolveAttributeGroupDefinition, resolveAttributeGroupDefinitionURI, resolveComplexTypeDefinition, resolveComplexTypeDefinitionURI, resolveElementDeclaration, resolveElementDeclarationURI, resolveIdentityConstraintDefinition, resolveIdentityConstraintDefinitionURI, resolveModelGroupDefinition, resolveModelGroupDefinitionURI, resolveNotationDeclaration, resolveNotationDeclarationURI, resolveSimpleTypeDefinition, resolveSimpleTypeDefinitionURI, resolveTypeDefinition, resolveTypeDefinitionURI, updateElement, updateElement`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Field Detail

### DOCUMENT_EDEFAULT

    protected static final org.w3c.dom.Document DOCUMENT_EDEFAULT

  The default value of the '`Document`' attribute.

  See Also:
    `getDocument()`

### document

    protected org.w3c.dom.Document document

  The cached value of the '`Document`' attribute.

  See Also:
    `getDocument()`

### SCHEMA_LOCATION_EDEFAULT

    protected static final java.lang.String SCHEMA_LOCATION_EDEFAULT

  The default value of the '`Schema Location`' attribute.

  See Also:
    `getSchemaLocation()`

### schemaLocation

    protected java.lang.String schemaLocation

  The cached value of the '`Schema Location`' attribute.

  See Also:
    `getSchemaLocation()`

### TARGET_NAMESPACE_EDEFAULT

    protected static final java.lang.String TARGET_NAMESPACE_EDEFAULT

  The default value of the '`Target Namespace`' attribute.

  See Also:
    `getTargetNamespace()`

### targetNamespace

    protected java.lang.String targetNamespace

  The cached value of the '`Target Namespace`' attribute.

  See Also:
    `getTargetNamespace()`

### ATTRIBUTE_FORM_DEFAULT_EDEFAULT

    protected static final XSDForm ATTRIBUTE_FORM_DEFAULT_EDEFAULT

  The default value of the '`Attribute Form Default`' attribute.

  See Also:
    `getAttributeFormDefault()`

### attributeFormDefault

    protected XSDForm attributeFormDefault

  The cached value of the '`Attribute Form Default`' attribute.

  See Also:
    `getAttributeFormDefault()`

### ATTRIBUTE_FORM_DEFAULT_ESETFLAG

    protected static final int ATTRIBUTE_FORM_DEFAULT_ESETFLAG

  The flag representing whether the Attribute Form Default attribute has been set.

  See Also:
    Constant Field Values

### ELEMENT_FORM_DEFAULT_EDEFAULT

    protected static final XSDForm ELEMENT_FORM_DEFAULT_EDEFAULT

  The default value of the '`Element Form Default`' attribute.

  See Also:
    `getElementFormDefault()`

### elementFormDefault

    protected XSDForm elementFormDefault

  The cached value of the '`Element Form Default`' attribute.

  See Also:
    `getElementFormDefault()`

### ELEMENT_FORM_DEFAULT_ESETFLAG

    protected static final int ELEMENT_FORM_DEFAULT_ESETFLAG

  The flag representing whether the Element Form Default attribute has been set.

  See Also:
    Constant Field Values

### finalDefault

    protected EList<XSDProhibitedSubstitutions> finalDefault

  The cached value of the '`Final Default`' attribute list.

  See Also:
    `getFinalDefault()`

### blockDefault

    protected EList<XSDDisallowedSubstitutions> blockDefault

  The cached value of the '`Block Default`' attribute list.

  See Also:
    `getBlockDefault()`

### VERSION_EDEFAULT

    protected static final java.lang.String VERSION_EDEFAULT

  The default value of the '`Version`' attribute.

  See Also:
    `getVersion()`

### version

    protected java.lang.String version

  The cached value of the '`Version`' attribute.

  See Also:
    `getVersion()`

### contents

    protected EList<XSDSchemaContent> contents

  The cached value of the '`Contents`' containment reference list.

  See Also:
    `getContents()`

### elementDeclarations

    protected EList<XSDElementDeclaration> elementDeclarations

  The cached value of the '`Element Declarations`' reference list.

  See Also:
    `getElementDeclarations()`

### attributeDeclarations

    protected EList<XSDAttributeDeclaration> attributeDeclarations

  The cached value of the '`Attribute Declarations`' reference list.

  See Also:
    `getAttributeDeclarations()`

### attributeGroupDefinitions

    protected EList<XSDAttributeGroupDefinition> attributeGroupDefinitions

  The cached value of the '`Attribute Group Definitions`' reference list.

  See Also:
    `getAttributeGroupDefinitions()`

### typeDefinitions

    protected EList<XSDTypeDefinition> typeDefinitions

  The cached value of the '`Type Definitions`' reference list.

  See Also:
    `getTypeDefinitions()`

### modelGroupDefinitions

    protected EList<XSDModelGroupDefinition> modelGroupDefinitions

  The cached value of the '`Model Group Definitions`' reference list.

  See Also:
    `getModelGroupDefinitions()`

### identityConstraintDefinitions

    protected EList<XSDIdentityConstraintDefinition> identityConstraintDefinitions

  The cached value of the '`Identity Constraint Definitions`' reference list.

  See Also:
    `getIdentityConstraintDefinitions()`

### notationDeclarations

    protected EList<XSDNotationDeclaration> notationDeclarations

  The cached value of the '`Notation Declarations`' reference list.

  See Also:
    `getNotationDeclarations()`

### annotations

    protected EList<XSDAnnotation> annotations

  The cached value of the '`Annotations`' reference list.

  See Also:
    `getAnnotations()`

### allDiagnostics

    protected EList<XSDDiagnostic> allDiagnostics

  The cached value of the '`All Diagnostics`' reference list.

  See Also:
    `getAllDiagnostics()`

### referencingDirectives

    protected EList<XSDSchemaDirective> referencingDirectives

  The cached value of the '`Referencing Directives`' reference list.

  See Also:
    `getReferencingDirectives()`

### incorporatedVersions

    protected EList<XSDSchema> incorporatedVersions

  The cached value of the '`Incorporated Versions`' containment reference list.

  See Also:
    `getIncorporatedVersions()`

### globalResourceSet

    protected static ResourceSet globalResourceSet

### xsdMagicSchemaForSchema2001

    protected static XSDSchema xsdMagicSchemaForSchema2001

### xsdSchemaForSchema2001

    protected static XSDSchema xsdSchemaForSchema2001

### xsdSchemaInstance2001

    protected static XSDSchema xsdSchemaInstance2001

### xsdMagicSchemaForSchema2000_10

    protected static XSDSchema xsdMagicSchemaForSchema2000_10

### xsdSchemaForSchema2000_10

    protected static XSDSchema xsdSchemaForSchema2000_10

### xsdMagicSchemaForSchema1999

    protected static XSDSchema xsdMagicSchemaForSchema1999

### xsdSchemaForSchema1999

    protected static XSDSchema xsdSchemaForSchema1999

### qNamePrefixToNamespaceMap

    protected java.util.Map<java.lang.String,java.lang.String> qNamePrefixToNamespaceMap

### schemaForSchemaQNamePrefix

    protected java.lang.String schemaForSchemaQNamePrefix

### hasRetargetedNamespace

    protected boolean hasRetargetedNamespace

### circularResolveDependencies

    protected java.util.Collection<XSDSchemaImpl> circularResolveDependencies

### simpleTypeIdMap

    protected java.util.Map<java.lang.String,XSDSimpleTypeDefinition> simpleTypeIdMap

### incorporatingSchemas

    protected java.util.List<XSDSchema> incorporatingSchemas

### eventListener

    protected org.w3c.dom.events.EventListener eventListener

### deletionNode

    protected org.w3c.dom.Node deletionNode

### isIncrementalUpdate

    protected boolean isIncrementalUpdate

### pendingSchemaLocation

    protected java.lang.String pendingSchemaLocation

### schemasToRedefine

    protected java.util.List<XSDSchemaImpl> schemasToRedefine

### redefinitionMap

    protected java.util.Map<XSDComponent,XSDComponent> redefinitionMap

Constructor Detail

### XSDSchemaImpl

    protected XSDSchemaImpl()

Method Detail

### createSchema

    public static XSDSchema createSchema(org.w3c.dom.Node node)

### createMetaSchema

    public static XSDSchema createMetaSchema(org.w3c.dom.Node node)

### getGlobalResourceSet

    public static ResourceSet getGlobalResourceSet()

### createResourceSet

    public static ResourceSet createResourceSet()

### getMagicSchemaForSchema

    public static XSDSchema getMagicSchemaForSchema(java.lang.String namespace)

### getSchemaForSchema

    public static XSDSchema getSchemaForSchema(java.lang.String namespace)

### getSchemaInstance

    public static XSDSchema getSchemaInstance(java.lang.String namespace)

### eStaticClass

    protected EClass eStaticClass()

  Overrides:
    `eStaticClass` in class `XSDScopeImpl`

### getDocument

    public org.w3c.dom.Document getDocument()

  Specified by:
    `getDocument` in interface `XSDSchema`
  Returns:
    the value of the 'Document' attribute.
  See Also:
    `XSDSchema.setDocument(Document)`, `XSDPackage.getXSDSchema_Document()`

### setDocument

    public void setDocument(org.w3c.dom.Document newDocument)

  Specified by:
    `setDocument` in interface `XSDSchema`
  Parameters:
    `newDocument` - the new value of the 'Document' attribute.
  See Also:
    `XSDSchema.getDocument()`

### getSchemaLocation

    public java.lang.String getSchemaLocation()

  Specified by:
    `getSchemaLocation` in interface `XSDSchema`
  Returns:
    the value of the 'Schema Location' attribute.
  See Also:
    `XSDSchema.setSchemaLocation(String)`, `XSDPackage.getXSDSchema_SchemaLocation()`

### setSchemaLocation

    public void setSchemaLocation(java.lang.String newSchemaLocation)

  Specified by:
    `setSchemaLocation` in interface `XSDSchema`
  Parameters:
    `newSchemaLocation` - the new value of the 'Schema Location' attribute.
  See Also:
    `XSDSchema.getSchemaLocation()`

### getTargetNamespace

    public java.lang.String getTargetNamespace()

  Specified by:
    `getTargetNamespace` in interface `XSDSchema`
  Returns:
    the value of the 'Target Namespace' attribute.
  See Also:
    `XSDSchema.setTargetNamespace(String)`, `XSDPackage.getXSDSchema_TargetNamespace()`

### setTargetNamespace

    public void setTargetNamespace(java.lang.String newTargetNamespace)

  Specified by:
    `setTargetNamespace` in interface `XSDSchema`
  Parameters:
    `newTargetNamespace` - the new value of the 'Target Namespace' attribute.
  See Also:
    `XSDSchema.getTargetNamespace()`

### getAttributeFormDefault

    public XSDForm getAttributeFormDefault()

  Specified by:
    `getAttributeFormDefault` in interface `XSDSchema`
  Returns:
    the value of the 'Attribute Form Default' attribute.
  See Also:
    `XSDForm`, `XSDSchema.isSetAttributeFormDefault()`, `XSDSchema.unsetAttributeFormDefault()`, `XSDSchema.setAttributeFormDefault(XSDForm)`, `XSDPackage.getXSDSchema_AttributeFormDefault()`

### setAttributeFormDefault

    public void setAttributeFormDefault(XSDForm newAttributeFormDefault)

  Specified by:
    `setAttributeFormDefault` in interface `XSDSchema`
  Parameters:
    `newAttributeFormDefault` - the new value of the 'Attribute Form Default' attribute.
  See Also:
    `XSDForm`, `XSDSchema.isSetAttributeFormDefault()`, `XSDSchema.unsetAttributeFormDefault()`, `XSDSchema.getAttributeFormDefault()`

### unsetAttributeFormDefault

    public void unsetAttributeFormDefault()

  Specified by:
    `unsetAttributeFormDefault` in interface `XSDSchema`
  See Also:
    `XSDSchema.isSetAttributeFormDefault()`, `XSDSchema.getAttributeFormDefault()`, `XSDSchema.setAttributeFormDefault(XSDForm)`

### isSetAttributeFormDefault

    public boolean isSetAttributeFormDefault()

  Specified by:
    `isSetAttributeFormDefault` in interface `XSDSchema`
  Returns:
    whether the value of the 'Attribute Form Default' attribute is set.
  See Also:
    `XSDSchema.unsetAttributeFormDefault()`, `XSDSchema.getAttributeFormDefault()`, `XSDSchema.setAttributeFormDefault(XSDForm)`

### getElementFormDefault

    public XSDForm getElementFormDefault()

  Specified by:
    `getElementFormDefault` in interface `XSDSchema`
  Returns:
    the value of the 'Element Form Default' attribute.
  See Also:
    `XSDForm`, `XSDSchema.isSetElementFormDefault()`, `XSDSchema.unsetElementFormDefault()`, `XSDSchema.setElementFormDefault(XSDForm)`, `XSDPackage.getXSDSchema_ElementFormDefault()`

### setElementFormDefault

    public void setElementFormDefault(XSDForm newElementFormDefault)

  Specified by:
    `setElementFormDefault` in interface `XSDSchema`
  Parameters:
    `newElementFormDefault` - the new value of the 'Element Form Default' attribute.
  See Also:
    `XSDForm`, `XSDSchema.isSetElementFormDefault()`, `XSDSchema.unsetElementFormDefault()`, `XSDSchema.getElementFormDefault()`

### unsetElementFormDefault

    public void unsetElementFormDefault()

  Specified by:
    `unsetElementFormDefault` in interface `XSDSchema`
  See Also:
    `XSDSchema.isSetElementFormDefault()`, `XSDSchema.getElementFormDefault()`, `XSDSchema.setElementFormDefault(XSDForm)`

### isSetElementFormDefault

    public boolean isSetElementFormDefault()

  Specified by:
    `isSetElementFormDefault` in interface `XSDSchema`
  Returns:
    whether the value of the 'Element Form Default' attribute is set.
  See Also:
    `XSDSchema.unsetElementFormDefault()`, `XSDSchema.getElementFormDefault()`, `XSDSchema.setElementFormDefault(XSDForm)`

### getFinalDefault

    public EList<XSDProhibitedSubstitutions> getFinalDefault()

  Specified by:
    `getFinalDefault` in interface `XSDSchema`
  Returns:
    the value of the 'Final Default' attribute list.
  See Also:
    `XSDProhibitedSubstitutions`, `XSDSchema.isSetFinalDefault()`, `XSDSchema.unsetFinalDefault()`, `XSDPackage.getXSDSchema_FinalDefault()`

### unsetFinalDefault

    public void unsetFinalDefault()

  Specified by:
    `unsetFinalDefault` in interface `XSDSchema`
  See Also:
    `XSDSchema.isSetFinalDefault()`, `XSDSchema.getFinalDefault()`

### isSetFinalDefault

    public boolean isSetFinalDefault()

  Specified by:
    `isSetFinalDefault` in interface `XSDSchema`
  Returns:
    whether the value of the 'Final Default' attribute list is set.
  See Also:
    `XSDSchema.unsetFinalDefault()`, `XSDSchema.getFinalDefault()`

### getBlockDefault

    public EList<XSDDisallowedSubstitutions> getBlockDefault()

  Specified by:
    `getBlockDefault` in interface `XSDSchema`
  Returns:
    the value of the 'Block Default' attribute list.
  See Also:
    `XSDDisallowedSubstitutions`, `XSDSchema.isSetBlockDefault()`, `XSDSchema.unsetBlockDefault()`, `XSDPackage.getXSDSchema_BlockDefault()`

### unsetBlockDefault

    public void unsetBlockDefault()

  Specified by:
    `unsetBlockDefault` in interface `XSDSchema`
  See Also:
    `XSDSchema.isSetBlockDefault()`, `XSDSchema.getBlockDefault()`

### isSetBlockDefault

    public boolean isSetBlockDefault()

  Specified by:
    `isSetBlockDefault` in interface `XSDSchema`
  Returns:
    whether the value of the 'Block Default' attribute list is set.
  See Also:
    `XSDSchema.unsetBlockDefault()`, `XSDSchema.getBlockDefault()`

### getVersion

    public java.lang.String getVersion()

  Specified by:
    `getVersion` in interface `XSDSchema`
  Returns:
    the value of the 'Version' attribute.
  See Also:
    `XSDSchema.setVersion(String)`, `XSDPackage.getXSDSchema_Version()`

### setVersion

    public void setVersion(java.lang.String newVersion)

  Specified by:
    `setVersion` in interface `XSDSchema`
  Parameters:
    `newVersion` - the new value of the 'Version' attribute.
  See Also:
    `XSDSchema.getVersion()`

### getContents

    public EList<XSDSchemaContent> getContents()

  Specified by:
    `getContents` in interface `XSDSchema`
  Returns:
    the value of the 'Contents' containment reference list.
  See Also:
    `XSDPackage.getXSDSchema_Contents()`

### getElementDeclarations

    public EList<XSDElementDeclaration> getElementDeclarations()

  Specified by:
    `getElementDeclarations` in interface `XSDSchema`
  Returns:
    the value of the 'Element Declarations' reference list.
  See Also:
    `XSDPackage.getXSDSchema_ElementDeclarations()`

### getAttributeDeclarations

    public EList<XSDAttributeDeclaration> getAttributeDeclarations()

  Specified by:
    `getAttributeDeclarations` in interface `XSDSchema`
  Returns:
    the value of the 'Attribute Declarations' reference list.
  See Also:
    `XSDPackage.getXSDSchema_AttributeDeclarations()`

### getAttributeGroupDefinitions

    public EList<XSDAttributeGroupDefinition> getAttributeGroupDefinitions()

  Specified by:
    `getAttributeGroupDefinitions` in interface `XSDSchema`
  Returns:
    the value of the 'Attribute Group Definitions' reference list.
  See Also:
    `XSDPackage.getXSDSchema_AttributeGroupDefinitions()`

### getTypeDefinitions

    public EList<XSDTypeDefinition> getTypeDefinitions()

  Specified by:
    `getTypeDefinitions` in interface `XSDSchema`
  Returns:
    the value of the 'Type Definitions' reference list.
  See Also:
    `XSDPackage.getXSDSchema_TypeDefinitions()`

### getModelGroupDefinitions

    public EList<XSDModelGroupDefinition> getModelGroupDefinitions()

  Specified by:
    `getModelGroupDefinitions` in interface `XSDSchema`
  Returns:
    the value of the 'Model Group Definitions' reference list.
  See Also:
    `XSDPackage.getXSDSchema_ModelGroupDefinitions()`

### getIdentityConstraintDefinitions

    public EList<XSDIdentityConstraintDefinition> getIdentityConstraintDefinitions()

  Specified by:
    `getIdentityConstraintDefinitions` in interface `XSDSchema`
  Returns:
    the value of the 'Identity Constraint Definitions' reference list.
  See Also:
    `XSDPackage.getXSDSchema_IdentityConstraintDefinitions()`

### getNotationDeclarations

    public EList<XSDNotationDeclaration> getNotationDeclarations()

  Specified by:
    `getNotationDeclarations` in interface `XSDSchema`
  Returns:
    the value of the 'Notation Declarations' reference list.
  See Also:
    `XSDPackage.getXSDSchema_NotationDeclarations()`

### getAnnotations

    public EList<XSDAnnotation> getAnnotations()

  Specified by:
    `getAnnotations` in interface `XSDSchema`
  Returns:
    the value of the 'Annotations' reference list.
  See Also:
    `XSDPackage.getXSDSchema_Annotations()`

### getAllDiagnostics

    public EList<XSDDiagnostic> getAllDiagnostics()

  Specified by:
    `getAllDiagnostics` in interface `XSDSchema`
  Returns:
    the value of the 'All Diagnostics' reference list.
  See Also:
    `XSDPackage.getXSDSchema_AllDiagnostics()`

### getReferencingDirectives

    public EList<XSDSchemaDirective> getReferencingDirectives()

  Specified by:
    `getReferencingDirectives` in interface `XSDSchema`
  Returns:
    the value of the 'Referencing Directives' reference list.
  See Also:
    `XSDPackage.getXSDSchema_ReferencingDirectives()`

### hasRetargetedNamespace

    public boolean hasRetargetedNamespace()

### getOriginalVersion

    public XSDSchema getOriginalVersion()

  Description copied from interface: `XSDSchema`
  Returns the value of the 'Original Version' reference.

  This represents the schema from which an `incorporated version` originates. The `root version` has itself as its original version.

  Specified by:
    `getOriginalVersion` in interface `XSDSchema`
  Returns:
    the value of the 'Original Version' reference.
  See Also:
    `XSDPackage.getXSDSchema_OriginalVersion()`

### getIncorporatedVersions

    public EList<XSDSchema> getIncorporatedVersions()

  Specified by:
    `getIncorporatedVersions` in interface `XSDSchema`
  Returns:
    the value of the 'Incorporated Versions' containment reference list.
  See Also:
    `XSDSchemaCompositor.getIncorporatedSchema()`, `XSDPackage.getXSDSchema_IncorporatedVersions()`

### getRootVersion

    public XSDSchema getRootVersion()

  Description copied from interface: `XSDSchema`
  Returns the value of the 'Root Version' reference.

  This walks the `original versions` until it hits one that has no original version.

  Specified by:
    `getRootVersion` in interface `XSDSchema`
  Returns:
    the value of the 'Root Version' reference.
  See Also:
    `XSDPackage.getXSDSchema_RootVersion()`

### getQNamePrefixToNamespaceMap

    public java.util.Map<java.lang.String,java.lang.String> getQNamePrefixToNamespaceMap()

  This returns the map defined by the xmlns attributes of the underlying XML representation.

  Specified by:
    `getQNamePrefixToNamespaceMap` in interface `XSDSchema`
  Returns:
    the map defined by the xmlns attributes of the underlying XML representation.
  See Also:
    `XSDSchema.getSchemaForSchemaQNamePrefix()`, `XSDSchema.getSchemaForSchemaNamespace()`

### getSchemaForSchemaQNamePrefix

    public java.lang.String getSchemaForSchemaQNamePrefix()

  This returns the QName prefix used to reference the schema for schema; it must be a key in `getQNamePrefixToNamespaceMap()`.

  Specified by:
    `getSchemaForSchemaQNamePrefix` in interface `XSDSchema`
  Returns:
    the QName prefix used to reference the schema for schema namespace.
  See Also:
    `XSDSchema.setSchemaForSchemaQNamePrefix(java.lang.String)`, `XSDSchema.getQNamePrefixToNamespaceMap()`

### setSchemaForSchemaQNamePrefix

    public void setSchemaForSchemaQNamePrefix(java.lang.String qNamePrefix)

  This sets the QName prefix used to reference the schema for schema; it must be a key in `getQNamePrefixToNamespaceMap()` that maps to a valid schema for schema namespace. It can also be used to rename the prefix, one it's established.

  Specified by:
    `setSchemaForSchemaQNamePrefix` in interface `XSDSchema`
  Parameters:
    `qNamePrefix` - the new schema for schema QName prefix.
  See Also:
    `XSDSchema.getSchemaForSchemaQNamePrefix()`, `XSDSchema.getQNamePrefixToNamespaceMap()`

### getSchemaForSchemaNamespace

    public java.lang.String getSchemaForSchemaNamespace()

  This returns (String)getQNamePrefixToNamespaceMap().get(getSchemaForSchemaQNamePrefix()); you can't set this directly.

  Specified by:
    `getSchemaForSchemaNamespace` in interface `XSDSchema`
  Returns:
    the schema for schema namespace.
  See Also:
    `XSDSchema.getQNamePrefixToNamespaceMap()`, `XSDSchema.getSchemaForSchemaQNamePrefix()`

### getStringBlockDefault

    public java.lang.String getStringBlockDefault()

  Description copied from interface: `XSDSchema`
  Returns the String value of the '`Block Default`' attribute list.

  Specified by:
    `getStringBlockDefault` in interface `XSDSchema`
  Returns:
    the String value of the 'Block Default' attribute list.
  See Also:
    `XSDSchema.getBlockDefault()`, `XSDSchema.setStringBlockDefault(java.lang.String)`

### setStringBlockDefault

    public void setStringBlockDefault(java.lang.String blockDefault)

  Description copied from interface: `XSDSchema`
  Returns the String value of the '`Block Default`' attribute list.

  Specified by:
    `setStringBlockDefault` in interface `XSDSchema`
  Parameters:
    `blockDefault` - the new value of the 'Block Default' attribute list.
  See Also:
    `XSDSchema.getBlockDefault()`, `XSDSchema.getStringBlockDefault()`

### getStringFinalDefault

    public java.lang.String getStringFinalDefault()

  Description copied from interface: `XSDSchema`
  Returns the String value of the '`Final Default`' attribute list.

  Specified by:
    `getStringFinalDefault` in interface `XSDSchema`
  Returns:
    the String value of the 'Final Default' attribute list.
  See Also:
    `XSDSchema.getFinalDefault()`, `XSDSchema.setStringFinalDefault(java.lang.String)`

### setStringFinalDefault

    public void setStringFinalDefault(java.lang.String finalDefault)

  Description copied from interface: `XSDSchema`
  Set the String value of the '`Final Default`' attribute list.

  Specified by:
    `setStringFinalDefault` in interface `XSDSchema`
  Parameters:
    `finalDefault` - the new value of the 'Final Default' attribute list.
  See Also:
    `XSDSchema.getFinalDefault()`, `XSDSchema.getStringFinalDefault()`

### createElement

    public org.w3c.dom.Element createElement()

  Overrides:
    `createElement` in class `XSDConcreteComponentImpl`

### traverseToRootForPatching

    protected void traverseToRootForPatching()

  Overrides:
    `traverseToRootForPatching` in class `XSDConcreteComponentImpl`

### computeSchemasToPatch

    protected void computeSchemasToPatch(XSDSchema root,
                                         java.util.List<XSDSchema> schemasToPatch)

### patch

    protected void patch()

  Overrides:
    `patch` in class `XSDConcreteComponentImpl`

### patchContents

    protected void patchContents()

### traverseToRootForAnalysis

    protected void traverseToRootForAnalysis()

  Overrides:
    `traverseToRootForAnalysis` in class `XSDConcreteComponentImpl`

### analyze

    protected boolean analyze()

  Overrides:
    `analyze` in class `XSDConcreteComponentImpl`

### validate

    public void validate()

  Description copied from interface: `XSDConcreteComponent`
  Validates whether this component conforms to the constraints defined in the XML Schema standard. `Diagnostics` are produced to report any problems. The effect of calling this for a component not directly or indirectly contained by a `schema` is undefined, and is likely to result in null pointer exceptions.

  Specified by:
    `validate` in interface `XSDConcreteComponent`
  Overrides:
    `validate` in class `XSDConcreteComponentImpl`
  See Also:
    `XSDConcreteComponent.getDiagnostics()`, `XSDConcreteComponent.clearDiagnostics()`

### validateNoDuplicates

    public void validateNoDuplicates(java.lang.String componentNoun,
                                     EList<? extends XSDNamedComponent> xsdNamedComponents)

### updateSortedList

    protected void updateSortedList(XSDNamedComponent xsdNamedComponent)

### adoptContent

    protected void adoptContent(EReference eReference,
                                XSDConcreteComponent xsdConcreteComponent)

  Overrides:
    `adoptContent` in class `XSDConcreteComponentImpl`

### orphanContent

    protected void orphanContent(EReference eReference,
                                 XSDConcreteComponent xsdConcreteComponent)

  Overrides:
    `orphanContent` in class `XSDConcreteComponentImpl`

### reconcileAttributes

    protected void reconcileAttributes(org.w3c.dom.Element changedElement)

  Overrides:
    `reconcileAttributes` in class `XSDConcreteComponentImpl`

### handleUnreconciledElement

    protected void handleUnreconciledElement(org.w3c.dom.Element child,
                                             java.util.List<XSDConcreteComponent> newContents,
                                             java.util.List<XSDConcreteComponent> remainingContents)

  Overrides:
    `handleUnreconciledElement` in class `XSDConcreteComponentImpl`

### handleReconciliation

    protected void handleReconciliation(java.util.List<XSDConcreteComponent> newContents,
                                        java.util.List<XSDConcreteComponent> remainingContents)

  Overrides:
    `handleReconciliation` in class `XSDConcreteComponentImpl`

### getCorrespondingComponent

    public XSDConcreteComponent getCorrespondingComponent(org.w3c.dom.Node node)

  Description copied from interface: `XSDSchema`
  Returns the best concrete component that corresponds to the given node. Since each concrete component has an associated element not a node, a best element is determined from the node first. Furthermore, since not every element corresponds to a concrete component, parent elements are considered when finding a match. The best match will be the deepest choice.

  Specified by:
    `getCorrespondingComponent` in interface `XSDSchema`
  Parameters:
    `node` - the node to find.
  Returns:
    the best concrete component that corresponds to the given node.
  See Also:
    `XSDConcreteComponent.getElement()`

### getSimpleTypeIdMap

    public java.util.Map<java.lang.String,XSDSimpleTypeDefinition> getSimpleTypeIdMap()

  Description copied from interface: `XSDSchema`
  Returns a map from String ID to `XSDSimpleTypeDefinition` based on the IDs in the DOM representation. For the `schema for schema`, this represents the built-in datatypes.

  Specified by:
    `getSimpleTypeIdMap` in interface `XSDSchema`
  Returns:
    a map from String ID to `XSDSimpleTypeDefinition`
  See Also:
    `XSDSchema.getSchemaForSchema()`

### getIncorporatingSchemas

    protected java.util.List<XSDSchema> getIncorporatingSchemas()

### resolveSchema

    public java.util.Collection<XSDSchema> resolveSchema(java.lang.String namespace)

  This returns set of schemas with the given namespace as it's target namespace.

### resolveNamedComponent

    protected XSDNamedComponent resolveNamedComponent(EReference namedComponentsRefReference,
                                                      java.lang.String namespace,
                                                      java.lang.String localName)

  This is a helper method for searching for a name in one of the schemas named component relations.

### resolveAttributeDeclaration

    public XSDAttributeDeclaration resolveAttributeDeclaration(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeDeclaration` in interface `XSDConcreteComponent`
  Overrides:
    `resolveAttributeDeclaration` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `XSDConcreteComponent.resolveAttributeDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveAttributeGroupDefinition

    public XSDAttributeGroupDefinition resolveAttributeGroupDefinition(java.lang.String namespace,
                                                                       java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute group definition the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeGroupDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveAttributeGroupDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute group definition
  See Also:
    `XSDConcreteComponent.resolveAttributeGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveElementDeclaration

    public XSDElementDeclaration resolveElementDeclaration(java.lang.String namespace,
                                                           java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved element declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveElementDeclaration` in interface `XSDConcreteComponent`
  Overrides:
    `resolveElementDeclaration` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `XSDConcreteComponent.resolveElementDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveElementDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveTypeDefinition

    public XSDTypeDefinition resolveTypeDefinition(java.lang.String namespace,
                                                   java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveTypeDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveTypeDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `XSDConcreteComponent.resolveTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveSimpleTypeDefinition

    public XSDSimpleTypeDefinition resolveSimpleTypeDefinition(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved simple type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveSimpleTypeDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveSimpleTypeDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `XSDConcreteComponent.resolveSimpleTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveSimpleTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveComplexTypeDefinition

    public XSDComplexTypeDefinition resolveComplexTypeDefinition(java.lang.String namespace,
                                                                 java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved complex type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveComplexTypeDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveComplexTypeDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `XSDConcreteComponent.resolveComplexTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveComplexTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveModelGroupDefinition

    public XSDModelGroupDefinition resolveModelGroupDefinition(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved model group definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveModelGroupDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveModelGroupDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `XSDConcreteComponent.resolveModelGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveModelGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveIdentityConstraintDefinition

    public XSDIdentityConstraintDefinition resolveIdentityConstraintDefinition(java.lang.String namespace,
                                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved identity constraint definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveIdentityConstraintDefinition` in interface `XSDConcreteComponent`
  Overrides:
    `resolveIdentityConstraintDefinition` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `XSDConcreteComponent.resolveIdentityConstraintDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveIdentityConstraintDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveNotationDeclaration

    public XSDNotationDeclaration resolveNotationDeclaration(java.lang.String namespace,
                                                             java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved notation declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveNotationDeclaration` in interface `XSDConcreteComponent`
  Overrides:
    `resolveNotationDeclaration` in class `XSDConcreteComponentImpl`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved notation declaration.
  See Also:
    `XSDConcreteComponent.resolveNotationDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveNotationDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### changeAttribute

    protected void changeAttribute(EAttribute eAttribute)

  Overrides:
    `changeAttribute` in class `XSDConcreteComponentImpl`

### changeReference

    protected void changeReference(EReference eReference)

  Overrides:
    `changeReference` in class `XSDConcreteComponentImpl`

### setElement

    public void setElement(org.w3c.dom.Element element)

  Description copied from interface: `XSDConcreteComponent`
  Sets the value of the '`Element`' attribute.

  Specified by:
    `setElement` in interface `XSDConcreteComponent`
  Overrides:
    `setElement` in class `XSDConcreteComponentImpl`
  Parameters:
    `element` - the new value of the 'Element' attribute.
  See Also:
    `XSDConcreteComponent.getElement()`

### getSchemaForSchema

    public XSDSchema getSchemaForSchema()

  Description copied from interface: `XSDSchema`
  Returns the value of the 'Schema For Schema' reference.

  This represents the 'schema for schemas'. It is computed from the `schema for schema namespace` and should typically not be set directly.

  Specified by:
    `getSchemaForSchema` in interface `XSDSchema`
  Returns:
    the value of the 'Schema For Schema' reference.
  See Also:
    `XSDPackage.getXSDSchema_SchemaForSchema()`

### eInverseRemove

    public NotificationChain eInverseRemove(InternalEObject otherEnd,
                                            int featureID,
                                            NotificationChain msgs)

  Overrides:
    `eInverseRemove` in class `XSDConcreteComponentImpl`

### eGet

    public java.lang.Object eGet(int featureID,
                                 boolean resolve,
                                 boolean coreType)

  Specified by:
    `eGet` in interface `InternalEObject`
  Overrides:
    `eGet` in class `XSDConcreteComponentImpl`

### eSet

    public void eSet(int featureID,
                     java.lang.Object newValue)

  Specified by:
    `eSet` in interface `InternalEObject`
  Overrides:
    `eSet` in class `XSDConcreteComponentImpl`

### eUnset

    public void eUnset(int featureID)

  Specified by:
    `eUnset` in interface `InternalEObject`
  Overrides:
    `eUnset` in class `XSDConcreteComponentImpl`

### eIsSet

    public boolean eIsSet(int featureID)

  Specified by:
    `eIsSet` in interface `InternalEObject`
  Overrides:
    `eIsSet` in class `XSDConcreteComponentImpl`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `XSDConcreteComponentImpl`

### getMagicSchemaForSchema

    public XSDSchema getMagicSchemaForSchema()

### getDeletionNode

    public org.w3c.dom.Node getDeletionNode()

### getEventListener

    protected org.w3c.dom.events.EventListener getEventListener()

### updateDocument

    public org.w3c.dom.Document updateDocument()

  Description copied from interface: `XSDSchema`
  Ensures that the `document` will be set to an instance that can be used to create a DOM serialization.

  Specified by:
    `updateDocument` in interface `XSDSchema`
  See Also:
    `XSDConcreteComponent.updateElement()`

### setIncrementalUpdate

    public void setIncrementalUpdate(boolean isIncrementalUpdate)

  Description copied from interface: `XSDSchema`
  Sets whether the schema will incrementally resolve QNames and perform analysis after each edit change. Setting this to `true` will also result in an update.

  Specified by:
    `setIncrementalUpdate` in interface `XSDSchema`
  Parameters:
    `isIncrementalUpdate` - the new value.
  See Also:
    `XSDSchema.isIncrementalUpdate()`, `XSDSchema.update()`

### isIncrementalUpdate

    public boolean isIncrementalUpdate()

  Description copied from interface: `XSDSchema`
  Returns whether the schema will incrementally resolve QNames and perform analysis after each edit change. Since a single incremental update can be very expensive, when a significant number of edit changes are expected to be made, performance can be improved by turning off incremental updates. In that case, QNames will remain unresolved and analysis results will not be updated; analysis involves things like propagating information from a base type to its derived types.

  Specified by:
    `isIncrementalUpdate` in interface `XSDSchema`
  Returns:
    whether the schema will incrementally resolve QNames and perform analysis.
  See Also:
    `XSDSchema.setIncrementalUpdate(boolean)`, `XSDSchema.update()`

### update

    public void update()

  Description copied from interface: `XSDSchema`
  Resolves QNames and performs analysis.

  Specified by:
    `update` in interface `XSDSchema`
  See Also:
    `XSDSchema.isIncrementalUpdate()`, `XSDSchema.update()`

### update

    public void update(boolean force)

  Description copied from interface: `XSDSchema`
  Resolves QNames and performs analysis. If `force` is `true` even previously resolved QNames are resolved again.

  Specified by:
    `update` in interface `XSDSchema`
  Parameters:
    `force` - whether previously resolved names should be resolved again.
  See Also:
    `XSDSchema.isIncrementalUpdate()`, `XSDSchema.update()`

### reset

    public void reset()

  Description copied from interface: `XSDSchema`
  Resets the effects of imports, includes, and redefines so that they will be reprocessed.

  Specified by:
    `reset` in interface `XSDSchema`
  Overrides:
    `reset` in class `XSDConcreteComponentImpl`
  See Also:
    `XSDSchema.update()`

### reset

    protected void reset(java.util.List<? extends XSDConcreteComponent> components)

### getPendingSchemaLocation

    public java.lang.String getPendingSchemaLocation()

### getSchemasToRedefine

    public java.util.List<XSDSchemaImpl> getSchemasToRedefine()

### getRedefinitionMap

    public java.util.Map<XSDComponent,XSDComponent> getRedefinitionMap()

### imported

    public XSDSchema imported(XSDImport xsdImport)

### propogateComponents

    public void propogateComponents(XSDSchema otherXSDSchema)

### redefined

    public XSDSchema redefined(XSDRedefine xsdRedefine)

### included

    public XSDSchema included(XSDInclude xsdInclude)

### incorporate

    protected void incorporate(XSDSchemaCompositor xsdSchemaCompositor)

### cloneConcreteComponent

    public XSDConcreteComponent cloneConcreteComponent(boolean deep,
                                                       boolean shareDOM)

  Description copied from interface: `XSDConcreteComponent`
  Creates a clone of the component. The clone may be deep and may share the DOM of this component.

  Specified by:
    `cloneConcreteComponent` in interface `XSDConcreteComponent`
  Overrides:
    `cloneConcreteComponent` in class `XSDConcreteComponentImpl`
  Parameters:
    `deep` - whether the clone should be deep.
    `shareDOM` - whether the clone should share the original DOM
  Returns:
    a clone of the component.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.